# bigip_monitor_external – Manages external LTM monitors on a BIG-IP

New in version 2.6.

- Synopsis

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Manages external LTM monitors on a BIG-IP.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
arguments string |  | Specifies any command-line arguments that the script requires.
description string added in 2.7 |  | The description of the monitor.
external_program string |  | Specifies the name of the file for the monitor to use. In order to reference a file, you must first import it using options on the System > File Management > External Monitor Program File List > Import screen. The BIG-IP system automatically places the file in the proper location on the file system.
interval integer |  | The interval specifying how frequently the monitor instance of this template will run. If this parameter is not provided when creating a new monitor, then the default value will be 5. This value must be less than the `timeout` value.
ip string |  | IP address part of the IP/port definition. If this parameter is not provided when creating a new monitor, then the default value will be '*'.
name string / required |  | Specifies the name of the monitor.
parent string | Default: "/Common/external" | The parent template of this monitor template. Once this value has been set, it cannot be changed. By default, this value is the `http` parent on the `Common` partition.
partition string | Default: "Common" | Device partition to manage resources on.
port string |  | Port address part of the IP/port definition. If this parameter is not provided when creating a new monitor, then the default value will be '*'. Note that if specifying an IP address, a value between 1 and 65535 must be specified.
provider dictionary added in 2.5 |  | A dict object containing connection details.
| auth_provider string |  | Configures the auth provider for to obtain authentication tokens from the remote device. This option is really used when working with BIG-IQ devices.
| password string / required |  | The password for the user account used to connect to the BIG-IP. You may omit this option by setting the environment variable `F5_PASSWORD`. aliases: pass, pwd
| server string / required |  | The BIG-IP host. You may omit this option by setting the environment variable `F5_SERVER`.
| server_port integer | Default: 443 | The BIG-IP server port. You may omit this option by setting the environment variable `F5_SERVER_PORT`.
| ssh_keyfile path |  | Specifies the SSH keyfile to use to authenticate the connection to the remote device. This argument is only used for cli transports. You may omit this option by setting the environment variable `ANSIBLE_NET_SSH_KEYFILE`.
| timeout integer |  | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.

transport
string

Choices:
- cli
- rest ←

Configures the transport connection to use when connecting to the remote device.

| user string / required |  | The username to connect to the BIG-IP with. This user must have administrative privileges on the device. You may omit this option by setting the environment variable `F5_USER`.

validate_certs
boolean

Choices:
- no
- yes ←

If `no`, SSL certificates are not validated. Use this only on personally controlled sites using self-signed certificates.
You may omit this option by setting the environment variable `F5_VALIDATE_CERTS`.

state
string

Choices:
- present ←
- absent

When `present`, ensures that the monitor exists.
When `absent`, ensures the monitor is removed.

timeout
integer

The number of seconds in which the node or service must respond to the monitor request.
If the target responds within the set time period, it is considered up.
If the target does not respond within the set time period, it is considered down.
You can change this number to any number you want, however, it should be 3 times the interval number of seconds plus 1 second.
If this parameter is not provided when creating a new monitor, then the default value will be `16`.

variables dictionary |  | Specifies any variables that the script requires. Note that double quotes in values will be suppressed.

## Notes

Note

- For more information on using Ansible to manage F5 Networks devices see https://www.ansible.com/integrations/networks/f5.

- Requires BIG-IP software version >= 12.

- The F5 modules only manipulate the running configuration of the F5 product. To ensure that BIG-IP specific configuration persists to disk, be sure to include at least one task that uses the bigip_config module to save the running configuration. Refer to the module’s documentation for the correct usage of the module to save your running configuration.

## Examples

    - name: Create an external monitor
      bigip_monitor_external:
        name: foo
        state: present
        provider:
          user: admin
          password: secret
          server: lb.mydomain.com
      delegate_to: localhost

    - name: Create an external monitor with variables
      bigip_monitor_external:
        name: foo
        timeout: 10
        variables:
          var1: foo
          var2: bar
        state: present
        provider:
          user: admin
          password: secret
          server: lb.mydomain.com
      delegate_to: localhost

    - name: Add a variable to an existing set
      bigip_monitor_external:
        name: foo
        timeout: 10
        variables:
          var1: foo
          var2: bar
          cat: dog
        state: present
        provider:
          user: admin
          password: secret
          server: lb.mydomain.com
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
description string | changed | The description of the monitor. Sample: Important Monitor
interval integer | changed | The new interval in which to run the monitor check. Sample: 2
ip string | changed | The new IP of IP/port definition. Sample: 10.12.13.14
parent string | changed | New parent template of the monitor. Sample: external
timeout integer | changed | The new timeout in which the remote system must respond to the monitor. Sample: 10

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by an Ansible Partner. [certified]

### Authors

- Tim Rupp (@caphrim007)

- Wojciech Wypior (@wojtek0806)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.